SystemOrganization addCategory: #'Daliot-FileSync'!
SystemOrganization addCategory: #'Daliot-common'!
SystemOrganization addCategory: #Daliot!

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:52'!
addIfNew: anObject 

	(self includes: anObject)
		ifFalse: [ self add: anObject ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 16:16'!
allMultiplied

	^self inject: 1 into: [:product :each| product * each ]! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 14:06'!
collectWith: aByteSymbol 

	^self collect: aByteSymbol accessingBlock! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 14:10'!
commonDivisors

	^(self collect: [:integer| integer exactDivisors ]) intersection! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 14:26'!
intersection

	| i |
	self revisit: 'This is reimplementation in Squeak. If you wanta better one, port it from Dolphin image.'.
	i := self first.
	self do: [:collection| i := i select: [:each| collection includes: each ] ].
	^i ! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:47'!
intersectionsWith: aRectangle 

	^(self collect: [:rectangle| rectangle intersect: aRectangle]) reject: [:rect| rect isEmpty ] ! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:06'!
isRedundant

	^self asSet size ~= self size! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 19:43'!
maximumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) last! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 19:47'!
minimumBy: accessingBlock

	^(self asSortedCollection: accessingBlock ascendingSortBlock) first! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:50'!
netArea

	^(self collect: [:shape| shape area ]) sum! !

!Collection methodsFor: '*Daliot' stamp: 'hjo 4/1/2008 12:14'!
sameMembers: aCollection

	^self size = aCollection size and: [
	(self copyWithoutAll: aCollection) isEmpty and: [
	(aCollection copyWithoutAll: self) isEmpty ]]
! !

TestCase subclass: #DaliotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/4/2008 19:17'!
testConcatenateAll

	self assertEquals: 'daysbikeDistancepushUpsdophinChangeLogSize' to: #('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAll.
	self assertEquals: #(1 2 3 4 10 11 12 13 14 15) to: {(1 to: 4). (10 to: 15)} concatenateAll.
	self assertEquals: (ByteArray withAll: #(50 10 20 100 110 120 200 220 250 254)) to: 
		(OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAll! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/4/2008 19:21'!
testConcatenateAllSeparatedBy

	self assertEquals: 'days bikeDistance pushUps dophinChangeLogSize' to: (#('days' 'bikeDistance' 'pushUps' 'dophinChangeLogSize') concatenateAllSeparatedBy: ' ').
	self assertEquals: #(1 2 3 4 $x 10 11 12 13 14 15) to: ({(1 to: 4) . (10 to: 15)} concatenateAllSeparatedBy: 'x').
	self assertEquals: (ByteArray withAll: #(50 10 20 1 2 3 100 110 120 1 2 3 200 220 250 254)) to: 
		((OrderedCollection new add: (ByteArray withAll: #(50 10 20));
		add: (ByteArray withAll: #(100 110 120));
		add: (ByteArray withAll: #(200 220 250 254));
		yourself) concatenateAllSeparatedBy: (ByteArray withAll: #(1 2 3)))! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2008 13:08'!
testEqualityComparison

	| ec |
	ec := EqualityComparison new selectors: {#x . #y}.
	
	self assert: (ec of: 1@1 and: 1@1).
	self deny: (ec of: 1@2 and: 1@1).
	self deny: (ec of: 2@1 and: 1@1)! !

!DaliotTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2008 17:39'!
testEqualityComparisonHashing

	| ec point |
	ec := EqualityComparison new selectors: {#x . #y}.
	point := 10@3.
	self assert: (ec hashOf: point) equals: (point x hash bitXor: point y hash) hash! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 16:10'!
testPointRotatedBy90Degrees

	self assert: (3@4) rotatedBy90Degrees equals: (-4 @ 3)! !

!DaliotTest methodsFor: 'point test' stamp: 'hjo 4/10/2008 12:19'!
testUnitPoint

	self assert: (3@4) unitPoint equals: (0.6 @ 0.8)! !

TestCase subclass: #FileSyncSideTest
	instanceVariableNames: 'o'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSideTest methodsFor: 'private' stamp: 'hjo 1/1/2008 23:20'!
answerForFullPathTest

	^'ab' , FileDirectory slash , 'cd'! !

!FileSyncSideTest methodsFor: 'running' stamp: 'hjo 1/1/2008 23:16'!
setUp

	super setUp.
	o := FileSyncSide new.
! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/5/2008 01:19'!
testIsFolder

	o path: 'root'.
	o itemName: 'folder'.
	self assert: (o isFolderContext: nil)! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:20'!
testSyncSide

	o path: 'ab'.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:21'!
testSyncSide2

	o path: 'ab'.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:29'!
testSyncSide3

	o path: 'ab' , FileDirectory slash.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:43'!
testSyncSide4

	o path: 'ab' , FileDirectory slash.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

TestCase subclass: #FileSyncTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:46'!
testDestinationSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs destinationSide fullPath = ('des' , FileDirectory slash , 'ff').
	! !

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:09'!
testReferenceSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs referenceSide fullPath = ('refe' , FileDirectory slash , 'ff').
	! !

TestCase subclass: #PointProjectionTest
	instanceVariableNames: 'referencePoint point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:00'!
setUp

	super setUp.
	point := 0@2.
	referencePoint := 4@3! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointTo

	self assert: (point projectionPointTo: referencePoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 16:01'!
testProjectionPointToUnitPoint

	self assert: (point projectionPointToUnitPoint: referencePoint unitPoint) equals: 0.96@0.72! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 14:10'!
testProjectionTo

	self assert: (point projectionTo: referencePoint) equals: 1.2! !

!PointProjectionTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/10/2008 15:50'!
testProjectionToUnitPoint

	self assert: (point projectionToUnitPoint: referencePoint unitPoint) equals: 1.2! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 4/3/2008 09:47'!
assert: evaluated equals: expected

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 4/3/2008 09:45'!
assert: expected equalsTo: evaluated

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!TestCase methodsFor: '*Daliot-common' stamp: 'hjo 3/31/2008 08:46'!
assertEquals: expected to: evaluated

	expected = evaluated
		ifFalse: [ self signalFailure: 'expected: ' , expected printString , '  but was: ' , evaluated printString ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:25'!
canMergeEastWith: aRectangle 

	^self right = aRectangle left and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeNorthWith: aRectangle 

	^self top = aRectangle bottom and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeSouthWith: aRectangle 

	^self bottom = aRectangle and: [ self leftAndRightIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:24'!
canMergeWestWith: aRectangle 

	^self left = aRectangle right and: [ self topAndBottomIsSameWith: aRectangle ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:19'!
canMergeWith: aRectangle 

	^(self canMergeNorthWith: aRectangle) or: [
	(self canMergeSouthWith: aRectangle) or: [
	(self canMergeWestWith: aRectangle) or: [
	(self canMergeEastWith: aRectangle) ]]]
! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:49'!
isEmpty

	^(self width<= 0) or: [self height <= 0]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:54'!
mergedEastWith: aRectangle 

	^ self left @ self top corner: aRectangle right @ aRectangle bottom! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:52'!
mergedWith: aRectangle 

	(self canMergeNorthWith: aRectangle) ifTrue: [^self mergedNorthWith: aRectangle].
	(self canMergeSouthWith: aRectangle) ifTrue: [^self mergedSouthWith: aRectangle].
	(self canMergeWestWith: aRectangle) ifTrue: [^self mergedWestWith: aRectangle].
	(self canMergeEastWith: aRectangle) ifTrue: [^self mergedEastWith: aRectangle]
! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 09:26'!
topAndBottomIsSameWith: aRectangle 

	^self top = aRectangle top and: [self bottom = aRectangle bottom ]! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:55'!
untruncatedCenter

	^(self origin + self corner)/2! !

!Rectangle methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:05'!
xRange

	^Range close: self left open: self right! !

!String class methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:58'!
fromLines: anArray

	^self streamContents: [:stream |

		anArray 
			do: [:each| stream nextPutAll: each ]
			separatedBy: [ "Dolphin 4: stream nextPutAll: self lineDelimiter" stream cr ].

	]! !

!String methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 10:30'!
lineFeedFiltered

	^self reject: [:character| character = Character lf ]! !

!String methodsFor: '*Daliot' stamp: 'hjo 3/27/2008 15:57'!
lines

	^self subStrings: '
'! !

!Random class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 12:44'!
globalRandom

	^Smalltalk at: 'GlobalRandom' ifAbsentPut: [ Random new ]! !

!ByteSymbol methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:14'!
accessingBlock

	^[:each| each perform: self ]! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/23/2008 20:15'!
equals: aNumber

	"Ported from Dolphin 4.0 by Howard J. Oh"
	| max significantDifference |
	significantDifference := 1.0e-9.
	^(max := self abs max: aNumber abs) <= significantDifference
		or: [(self-aNumber) abs < (significantDifference * max)]! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:03'!
equals: trueNumber withError: errorNumber

	^(self - trueNumber) abs <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:05'!
equals: trueNumber withRelativeError: errorNumber

	^(self relativeTo: trueNumber) <= errorNumber! !

!Number methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:42'!
quoAndRem: aNumber

	^{self quo: aNumber . self rem: aNumber}! !

!Number methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 14:06'!
relativeTo: trueNumber

	^(self - trueNumber)/trueNumber
! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 11:35'!
canAccessAtRow: integer1 atColumn: integer2

	^(integer1 between: 1 and: self rowCount) and: [
		(integer2 between: 1 and: self columnCount)
		]! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:34'!
insertDiagonal: anArray 

	| diagonalStream nondiagonalStream matrix |
	diagonalStream := anArray readStream.
	nondiagonalStream := contents readStream.
	matrix := self species rows: nrows columns: ncols+1.
	
	matrix indicesDo: [:ri :ci | matrix at: ri at: ci put: (ri=ci ifTrue:[diagonalStream next] ifFalse:[nondiagonalStream next]) ].
	^matrix! !

!Matrix methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:15'!
readFromTextStream: aReadStream 

	self indicesDo: [ :ri :ci | self at: ri at: ci put: aReadStream nextNumberFromText ]! !

!Dictionary methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 20:18'!
at: key add: element

	(self at: key ifAbsentPut: [OrderedCollection new]) add: element
	! !

!UndefinedObject methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^false! !

!ArrayedCollection methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 11:17'!
includesKey: anInteger 

	self isEmpty ifTrue: [^false].
	^anInteger between: 1 and: self size ! !

TestRunner subclass: #DaliotsTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:22'!
browseUnsentMessages
| sentClasses methods  coveredMethods uncoveredMethods references |

	references := classesSelected gather: [ :class |
		class methodDict values , class class methodDict values gather: [ :method |
			(method literals copyWithoutAll: class allSelectors , class class allSelectors)
				select: [ :each | each isSymbol ] ] ].

	coveredMethods := OrderedCollection new.
	references
		do: [:each | coveredMethods addAll: (SystemNavigation new allImplementorsOf: each) ].
sentClasses := Smalltalk allClasses select: [:c| (c category = #EcologicalBinPacking) and: [ c superclass ~= TestCase ]].
	methods := OrderedCollection new.
	sentClasses do: [:ee| ee selectors do: [:ss| methods add: (MethodReference class:ee selector: ss) ]].

	coveredMethods := coveredMethods select: [:me| |class| class := Smalltalk at: me classSymbol. class category =  #EcologicalBinPacking].

	uncoveredMethods := methods copyWithoutAll: coveredMethods. 
	SystemNavigation new browseMessageList: uncoveredMethods name: 'Untested Methods' ! !

!DaliotsTestRunner methodsFor: 'accessing-classes' stamp: 'hjo 3/28/2008 11:16'!
classMenu: aMenu
	| menu |
	menu := aMenu
		title: 'Classes';
		yourself.
	self browserEnvironment notNil ifTrue: [ 
		menu
			add: 'Browse classes' action: #browseTestClasses;
			add: 'Browse referenced classes' action: #browseReferencedClasses ].
	^ menu
		add: 'Browse sent messages' action: #browseSentMessages;
		add: 'Browse unsent messages' action: #browseUnsentMessages;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Refresh' action: #updateClasses;
		yourself.! !

!PasteUpMorph methodsFor: '*Daliot' stamp: 'hjo 3/25/2008 18:05'!
collapseAllSystemWindows

	(self submorphs select: [:so| so class = SystemWindow ]) do: [: ow | ow collapse ]! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:03'!
colinear: p1 with: p2

	^((self-p1) crossProduct: (self-p2)) = 0! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:24'!
equals: aPoint 

	^(self x equals: aPoint x) and: [self y equals: aPoint y]! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 12:56'!
pointRectangle

	^self corner: self copy! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 08:09'!
polygonAreaKernel: backPoint with: forePoint

	^self y * (forePoint x - backPoint x)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:42'!
projectionPointTo: aPoint 

	^self projectionPointToUnitPoint: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:26'!
projectionPointToUnitPoint: aPoint 

	^aPoint * (aPoint dotProduct: self)! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 14:14'!
projectionTo: aPoint 

	^self dotProduct: aPoint unitPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:32'!
projectionToUnitPoint: aPoint 

	^self dotProduct: aPoint! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 16:09'!
rotatedBy90Degrees

	^self y negated @ self x! !

!Point methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 12:19'!
unitPoint

	^self / self r! !

!MethodContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:22'!
senderChainIncludesSelector: aByteSymbol 

	^sender selector = aByteSymbol or: [ sender senderChainIncludesSelector: aByteSymbol ]! !

!CompiledMethod class methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 10:15'!
categoriesUsedFor: aByteSymbol 

	^((self allInstances select: [:each| each selector = aByteSymbol ])
		collect: [:each | each methodCategory ]) asBag
	
	! !

!CompiledMethod methodsFor: '*Daliot' stamp: 'hjo 4/10/2008 10:08'!
methodCategory

	^self methodClass organization categoryOfElement: self selector! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 16:11'!
exactDivisors

	|ed sq |
	ed := OrderedCollection new.
	sq := self sqrt truncated.
	sq squared = self ifTrue: [ed add: sq. sq := sq-1].
	sq to: 1 by: -1 do: [ :d |
		( self rem: d ) = 0
			ifTrue: [
				ed addFirst: d.
				ed addLast: self/d
			]
	].
	^ed asArray! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 12:21'!
isRelativelyPrimeTo: anInteger

	^(self gcd: anInteger) = 1! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 14:59'!
primeFactors

	^self standardDecomposition asSet! !

!Integer methodsFor: '*Daliot' stamp: 'hjo 4/7/2008 14:57'!
standardDecomposition

	| sd d x |
	sd := Bag new.
	d := 2.
	x := self.

	[x >= d] whileTrue: [
		(x rem: d) = 0
			ifTrue: 
			[
				x := x / d.
				sd add: d
			]
			ifFalse:
			[
				d := d + 1
			]
	].
	^sd! !

!PositionableStream methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 10:43'!
collection

	^collection! !

!SequenceableCollection class methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 13:54'!
writeStream

	"Dolphin Method"
	^self new writeStream! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 19:16'!
concatenateAll

	^self concatenateAllSeparatedBy: self species new! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 19:16'!
concatenateAllSeparatedBy: aCollection

	|stream|
	stream := self first species writeStream.
	self do: [:each| stream nextPutAll: each ] separatedBy: [stream nextPutAll: aCollection].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 15:40'!
copyFrom1ToSubCollectionIndexMinus1: anArray

	^self copyFrom: 1 to: (self indexOfSubCollection: anArray)-1! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:55'!
do: aBlockClosure spanSize2: anInteger

	"Slower than #do:spanSize: , but better understandable."
	| span feeder |
	
	span := OrderedCollection withAll: (self copyTo: anInteger).
	feeder := (self copyFrom: anInteger+1) readStream.

	[ aBlockClosure value: span. feeder atEnd ]
	whileFalse: 
	[
		span removeFirst.
		span addLast: feeder next.
	]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/4/2008 18:41'!
do: aBlockClosure spanSize: anInteger

	|previousItems|

	anInteger-1 > self size ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: 1 to: anInteger-1).
	anInteger to: self size do:
		[:i| previousItems addLast: (self at:i).
		aBlockClosure value: previousItems.
		previousItems removeFirst]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 08:54'!
doCouple: aBlockClosure

	self do: [:x| aBlockClosure value: x first value: x second] spanSize: 2
! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 4/13/2008 13:32'!
doRolled: aBlockClosure spanSize: anInteger 

	|previousItems|

	self size < anInteger ifTrue: [^self].
	previousItems := OrderedCollection withAll: (self copyFrom: self size - anInteger + 2).
	self do: [:each| 
		previousItems addLast: each. 
		aBlockClosure value: previousItems. 
		previousItems removeFirst ]! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:20'!
multiDimensionalCollect: monoBlock 

	|stream|
	stream := self species writeStream.
	self multiDimensionalDo: [:sample| stream nextPut: (monoBlock value: sample) ].
	^stream contents! !

!SequenceableCollection methodsFor: '*Daliot' stamp: 'hjo 3/24/2008 12:37'!
multiDimensionalDo: monoBlock

	self isEmpty ifTrue: [^self].
	self size = 1 ifTrue: [^self first do: [:oneParam| monoBlock value: (Array with: oneParam)]].
	self first do: [:first| 
		(self copyFrom: 2 to: self size) multiDimensionalDo: [:paramWithoutFirst|
			monoBlock value: (Array with: first) , paramWithoutFirst
		]]! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:17'!
ascendingSortBlock

	^[:objectA :objectB | (objectA perform: self) < (objectB perform: self) ]! !

!Symbol methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:22'!
descendingSortBlock

	^[:objectA :objectB | (objectA perform: self) > (objectB perform: self) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:14'!
ascendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) < (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/17/2008 17:21'!
descendingSortBlock

	self assert: [self argumentCount = 1].
	^[:objectA :objectB | (self value: objectA) > (self value: objectB) ]! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:23'!
senderChainIncludesSelector: aByteSymbol 

	^ sender senderChainIncludesSelector: aByteSymbol ! !

!BlockContext methodsFor: '*Daliot' stamp: 'hjo 3/29/2008 21:39'!
valueAllWithArguments: anArray 

	^anArray collect: [:parameterArray|   self valueWithArguments: parameterArray ]! !

!BlockContext methodsFor: '*Daliot-common' stamp: 'hjo 3/18/2008 21:21'!
whileFalse: aBlockContext loopLimit: anInteger 

	|loopCount|
	loopCount := 0.
	self whileFalse: [aBlockContext value. loopCount := loopCount + 1. loopCount > anInteger ifTrue: [self error: 'Infinite loop suspected.' ] ]! !

Object subclass: #EqualityComparison
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!EqualityComparison methodsFor: 'evaluating' stamp: 'hjo 4/8/2008 17:40'!
hashOf: anObject

	^(selectors inject: 0 into: [:hash :symbol| hash bitXor: (abObject perform: symbol) hash]) hash! !

!EqualityComparison methodsFor: 'evaluating' stamp: 'hjo 4/8/2008 13:05'!
of: object1 and: object2

	^selectors allSatisfy: [:symbol| (object1 perform: symbol) = (object2 perform: symbol) ]! !

!EqualityComparison methodsFor: 'accessing' stamp: 'hjo 4/8/2008 13:06'!
selectors: arrayOfSymbols

	selectors := arrayOfSymbols! !

Object subclass: #FileSync
	instanceVariableNames: 'referencePath fileName destinationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSync classSide methodsFor: 'instance creation' stamp: 'hjo 1/1/2008 03:35'!
from: aByteString to: aByteString2 for: aByteString3 

	^self new
		referencePath: aByteString;
		destinationPath:aByteString2;
		fileName:aByteString3;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:26'!
destinationFile
	^FileDirectory on: destinationPath , FileDirectory slash , fileName! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:36'!
destinationPath: aByteString 
	destinationPath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:48'!
destinationSide
	
	^FileSyncSide new
		path: destinationPath;
		itemName: fileName;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:37'!
fileName: aByteString 
	fileName :=aByteString! !

!FileSync methodsFor: 'creation' stamp: 'hjo 1/1/2008 02:20'!
init
	referencePath := 'refe'.
	destinationPath := 'des'.
	fileName := 'ff'! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:35'!
referencePath: aByteString 
	referencePath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:11'!
referenceSide
	
	^FileSyncSide new
		path: referencePath;
		itemName: fileName;
		yourself! !

Object subclass: #FileSyncSide
	instanceVariableNames: 'path itemName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:42'!
fullPath

	^(path endsWithThese: FileDirectory slash)
		ifTrue: [self fullPathIfPathLastIsSlash]
		ifFalse: [self fullPathIfPathLastIsNotSlash]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:35'!
fullPathIfPathLastIsNotSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [path , itemName]
		ifFalse: [path , FileDirectory slash , itemName]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:37'!
fullPathIfPathLastIsSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [ path , itemName copyWithoutFirst ]
		ifFalse: [ path , itemName ]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:04'!
itemName: aString

	itemName :=aString! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:03'!
path: aString

	path := aString! !

Object subclass: #IDontKnow
	instanceVariableNames: 's d stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:27'!
encodeMacDirectory: aFileDirectory

	^String streamContents: [:ssss | 
		self encodeMacDirectory: aFileDirectory on: ssss ]! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:37'!
encodeMacDirectory: aFileDirectory on: pathStream

	aFileDirectory fullName = FileDirectory root fullName
		ifFalse: [ self encodeMacDirectory: aFileDirectory on: pathStream containingDirectory ].
		
	pathStream nextPutAll: FileDirectory slash.
	pathStream nextPutAll: (self encodeMacFileName: aFileDirectory fullName)! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:35'!
encodeMacFileName: aString

	^String streamContents:
		[:encoded|
			aString
				do: [:char| 
					self assert: [(':' includes: char) not].
					('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-^{},+' includes: char) 
					ifTrue: [encoded nextPut: char ] 
					ifFalse: [
						char = $/ ifTrue: [encoded nextPut: $:] ifFalse: [encoded nextPut: $\; nextPut: char] ] ]	
		]

	! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:01'!
go

	s entries do: [:e|
		e isDirectory
			ifTrue: [ self goDirectory: e ]
			ifFalse: [ self goFile: e  ] 
		 ].
	^self stream contents! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:56'!
goDirectory: e 

	self streamMakeDir: e.
	(self subDir: e name)
		stream: self stream;
		go! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:18'!
goFile: e

	self stream 
		nextPutAll: 'cp -p '; 
		nextPutAll: (self encodeMacFileName: s fullName);
		nextPutAll: FileDirectory slash;
		nextPutAll: (self encodeMacFileName:e name);
		space;
		nextPutAll: (self encodeMacFileName: d fullName);
		nextPutAll: ';';
		cr! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:18'!
s: fd1 d: fd2

	s := fd1.
	d := fd2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 05:02'!
sp: s1 dp: s2

	s := FileDirectory on: s1.
	d := FileDirectory on: s2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 13:38'!
stream

	stream isNil ifTrue: 
		[stream := WriteStream on: ByteString new].
	^stream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:17'!
stream: aWriteStream

	stream := aWriteStream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 11:28'!
streamMakeDir: e
	
	{ 'mkdir '. self encodeMacFileName: (d fullName, FileDirectory slash, e name). ';' }
		do: [:part| self stream nextPutAll: part].
		
	self stream cr
! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:19'!
subDir: aString

	^self class new
		s: (s directoryNamed: aString)
		d: (d directoryNamed: aString)! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/5/2008 10:32'!
haltFor: aByteSymbol 
	
	(thisContext senderChainIncludesSelector: aByteSymbol)
		ifTrue: [self halt]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 13:29'!
printOn: aStream tabLevel: anInteger

	aStream tab: anInteger.
	self printOn: aStream	! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/31/2008 09:51'!
printStringTabLevel: anInteger

	^String streamContents: [:stream| self printOn: stream tabLevel: anInteger ]! !

!Object methodsFor: '*Daliot' stamp: 'hjo 3/18/2008 18:45'!
revisit: aString

	"does nothing"! !

Object subclass: #SSTrainer
	instanceVariableNames: 'history delta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:40'!
delta

	delta isNil ifTrue: [ self delta: {1 . 1 . 1 . 1} ].
	^delta! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:39'!
delta: anArray

	delta := anArray! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:38'!
history

	history isNil ifTrue: [ self history: (OrderedCollection with: (SquareSum new)) ].
	^history! !

!SSTrainer methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:38'!
history: anOrderedCollection

	history := anOrderedCollection! !

!SSTrainer methodsFor: 'looping' stamp: 'hjo 4/7/2008 09:50'!
step

	| champion challenger |
	champion := self history last.
	
	challenger := ( champion variationsWithDelta: self delta ) minimumBy: #e.
	
	champion e > challenger e
		ifTrue: [ self history addLast: challenger ]
		ifFalse: [ self delta: self delta / 2 ]
	
	! !

!SSTrainer methodsFor: 'looping' stamp: 'hjo 4/7/2008 09:52'!
step: anInteger

	anInteger timesRepeat: [self step]! !

Object subclass: #SquareSum
	instanceVariableNames: 'a b c d h1 h2 h3 h4 v1 v3 v4 e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot'!

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
a

	a isNil ifTrue: [ self a: 1 ].
	^a! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:19'!
a: aNumber

	self h1: nil.
	self h3: nil.
	self h4: nil.
	self v1: nil.
	self v4: nil.
	a := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
b

	b isNil ifTrue: [ self b: 1 ].
	^b! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:21'!
b: aNumber

	self h1: nil.
	self h2: nil.
	self h4: nil.
	self v3: nil.
	self v4: nil.

	b := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
c

	c isNil ifTrue: [ self c: 1 ].
	^c! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:22'!
c: aNumber

	self h1: nil.
	self h2: nil.
	self h3: nil.
	self h4: nil.
	self v1: nil.
	self v3: nil. 

	c := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:28'!
d

	d isNil ifTrue: [ self d: 1 ].
	^d! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:23'!
d: aNumber

	self h1: nil.
	self h2: nil.
	self h3: nil.
	self v1: nil.
	self v3: nil.
	self v4: nil.

	d := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:17'!
e

	e isNil ifTrue: [ self e: self h1 + self h2 + self h3 + self h4 + self v1 + self v3 + self v4 ].
	^e
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:06'!
e: aNumber

	e := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:07'!
h1

	h1 isNil ifTrue: [ self h1: (self a + self b + self c + self d - 27) squared ].
	^h1
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:03'!
h1: aNumber
	
	self e: nil.
	h1 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:10'!
h2

	h2 isNil ifTrue: [ self h2: (d + c+ b + b - 21) squared ].
	^h2! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h2: aNumber
	
	self e: nil.
	h2 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:11'!
h3

	h3 isNil ifTrue: [ self h3: (c + a + d + a - 27) squared ].
	^h3! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h3: aNumber
	
	self e: nil.
	h3 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:12'!
h4

	h4 isNil ifTrue: [ self h4: (a + b + c+ a - 23) squared ].
	^h4! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:04'!
h4: aNumber
	
	self e: nil.
	h4 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:14'!
v1

	v1 isNil ifTrue: [ self v1: (a + d + c + a - 27) squared ].
	^v1
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v1: aNumber
	
	self e: nil.
	v1 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:15'!
v3

	v3 isNil ifTrue: [ self v3: (c + b + d + c - 26) squared ].
	^v3
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v3: aNumber
	
	self e: nil.
	v3 := aNumber! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:16'!
v4

	v4 isNil ifTrue: [ self v4: (d + b + a + a - 22) squared ].
	^v4
! !

!SquareSum methodsFor: 'accessing' stamp: 'hjo 4/7/2008 09:05'!
v4: aNumber
	
	self e: nil.
	v4 := aNumber! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 08:48'!
variationAp

	^self copy
		a: self a + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:18'!
variationBp

	^self copy
		b: self b + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:18'!
variationCp

	^self copy
		c: self c + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:24'!
variationDp

	^self copy
		d: self d + 1! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:55'!
variations

	^self variationsWithDelta: #(1 1 1 1)! !

!SquareSum methodsFor: 'variations' stamp: 'hjo 4/7/2008 09:43'!
variationsWithDelta: anArray 

	^{
		self copy a: (self a + anArray first).
		self copy b: (self b + anArray second).
		self copy c: (self c + anArray third).
		self copy d: (self d + anArray fourth).
	}! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:22'!
nextNumberFromText

	[^self upToSeparator asNumber] ensure: [self skipSeparators]! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/8/2008 09:51'!
nextSquareMatrixFromText

	| matrixSize  |
	matrixSize := self nextNumberFromText.
	^Matrix rows: matrixSize columns: matrixSize contents:
		(Array streamContents: [:contentsStream | 
			matrixSize squared timesRepeat: [ contentsStream nextPut: self nextNumberFromText ].
		]).
! !

!ReadStream methodsFor: '*Daliot' stamp: 'hjo 4/3/2008 15:56'!
upToSeparator

	| posWhenCalled posFound |
	posWhenCalled := self position.
	[self atEnd or: [self peek isSeparator]] whileFalse: [self skip:1].
	posFound := self position.
	self position: posWhenCalled.
	^self next: (posFound-posWhenCalled)! !
